<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  Content.emailcloak
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\String\StringHelper;

/**
 * Email cloack plugin class.
 *
 * @since  1.5
 */
class PlgContentVirtuemart_electroneum_prices extends JPlugin
{
    public function __construct(& $subject, $config)
	{
		 parent::__construct($subject, $config);
		 
		 if(JFactory::getApplication()->isAdmin()) {
			return;
		}
		$ajaxtask = JRequest::getVar("ajaxtask");
		if($ajaxtask == 'electronumprices')
		{
			$pid = JRequest::getVar("vmid");
			
			if (!class_exists( 'VmConfig' )) require(JPATH_ROOT .'/administrator/components/com_virtuemart/helpers/config.php');
			
			VmConfig::loadConfig();
			vmRam('Start');
			vmSetStartTime('vmStart');
			vmLanguage::loadJLang('com_virtuemart', true);
			
			$pModel = VmModel::getModel('product');
			$product = $pModel->getProduct($pid, true, true,true,1);
			$currency = CurrencyDisplay::getInstance( );
			$currencycode = $currency->_vendorCurrency_code_3;
			
			$amountval = $product->prices['salesPrice'];
			
			
			
			 $urlsupply = 'https://supply.electroneum.com/app-value-v2.json';
			 $json = file_get_contents($urlsupply);
			
		
			 
			 $jsonsarray = json_decode($json, true);
			 
			
			 $etnvalue = $jsonsarray['price_'.strtolower($currencycode)];

			 $convertedamount = number_format(floatval($amountval) / $etnvalue, 2, '.', ''); 
			 
			 $html = '';
			 $background = "#f6f6f6";
			 $border = '#e6e6e6';
			 $color = '#868585';
			 $align = 'left';
			
			 $html.= '<table id="etn_div" style="width:150px; display:auto; text-align:center; margin:10px 0;   background:'.$background.'; border: 1px solid '.$border.'"><tr>';
						
			 $borderstring = "";
			
			 	//$html.= '<td style="padding:5px; width:35px; line-height:10px;"><img src="'.JURI::Base().'plugins/content/virtuemart_electroneum_prices/images/etn.svg" style="width:35px !important; height:29px !important; padding-right:5px;  border-right: 1px solid '.$border.'; padding-bottom:0px !important;" /></td>';

			  $html.= '<td style="text-align:center;"><img src="https://timg.electroneum.com/Pixel_Tracker?platform=etn" style="width:auto !important; height:auto !important;border-bottom:1px solid '.$border.';padding-bottom:5px !important;" /></td>'; 
		
			 
			
			 $html.= '</tr><tr>';
			$html.= '<td style="padding:5px; text-align:center; vertical-align:middle;"><strong style="  color:'.$color.'; ">'.$convertedamount.' ETN</strong></td>';
			 $html.= '</tr><table>'; 
			 
			 
			 
			 $return = array();
			 $return['html'] = $html;
			 
			 echo json_encode($return);
			 exit;
		}
	}
	
	 public function onContentPrepare($context, &$article, &$params, $page = 0)
	 {
	 
	  
	    $option = JRequest::getVar("option");
		$view  = JRequest::getVar("view");
	
		if($option == "com_virtuemart" && $view == "productdetails")
		{
			$vmid = JRequest::getVar("virtuemart_product_id");
			$document = JFactory::getDocument();
			
			$document->addScriptDeclaration('
			  
			  jQuery(document).ready(function(){

				  Siteurl = "'.JURI::Base().'";
				  jQuery.ajax({
						type: "POST",
						cache: false,
						dataType: "json",
						url: Siteurl + "index.php?&ajaxtask=electronumprices&vmid='.$vmid.'",
						data :  jQuery("#klarna_fields :input").serialize(),
					}).done(
					function (data, textStatus){
						jQuery("#etn_div").remove();
						jQuery(".productdetails-view .product-price:first").after(data.html);
					});
			  });
			');
		}

		if ($context === 'com_finder.indexer')  
		{
			return true;   
		}
		
		if (strpos($article->text, '{etncommerce ') === false && strpos($article->text, '{etncommerce ') === false)
		{
			return true;
		}
		


			// Expression to search for
			$pattern = '#\{etncommerce ([0-9]+)(.*?)?\}#i';
			// Found matches
			if (preg_match_all($pattern, $article->text, $matches)) {
				// No replacement when we're not dealing with HTML
				if (JFactory::getDocument()->getType() != 'html') {
					$text = preg_replace($pattern, '', $text);
					return true;
				}
				
			
				// Disable caching
				$cache = JFactory::getCache('com_content');
				$cache->setCaching(false);
				
				
				 $urlsupply = 'https://supply.electroneum.com/app-value-v2.json';
				 $json = file_get_contents($urlsupply);
				 
				  $jsonsarray = json_decode($json, true);
				 
		

				foreach ($matches[0] as $i => $fullMatch)
				{

					$attributes = trim($matches[2][$i]);
					if (preg_match_all('#[a-z0-9_\-]+=".*?"#i', $attributes, $attributesMatches))
					{
						$data = array();
						
						
						
						foreach ($attributesMatches[0] as $pair)
						{
							list($attribute, $value) = explode('=', $pair, 2);
							
							$attribute  = trim(html_entity_decode($attribute));
							$value 		= html_entity_decode(trim($value, '"'));
							
							if (isset($data[$attribute]))
							{
								if (!is_array($data[$attribute]))
								{
									$data[$attribute] = (array) $data[$attribute];
								}
								
								$data[$attribute][] = $value;
							}
							else
							{
								$data[$attribute] = $value;
							}
						}
						
						
					}
					$amountval = $matches[1][$i];
					
				    $html = '';
					 
					if(!empty($amountval))
					{
						
						$html = '';
						$currency = "EUR";
						$image = "show";
						$background = "#f6f6f6";
						$border = '#e6e6e6';
						$color = '#868585';
						$align = 'left';
						
						if(!empty($data['currency']))
						{
							  $currency = $data['currency'];
						}
						if(!empty($data['image']))
						{
							  $image = $data['image'];
						}
						if(!empty($data['background']))
						{
							  $background = $data['background'];
						}
						if(!empty($data['currency']))
						{
							  $border = $data['border'];
						}
						if(!empty($data['color']))
						{
							  $color = $data['color'];
						}
						if(!empty($data['align']))
						{
							  $align = $data['align'];
						}
						  
						 if($align == 'center')
						 {
							 $aligncss = "margin:10px auto";
						 }
						 else if($align == 'right')
						 {
							 $aligncss = "float:right;";
						 }
						
						 $html.= '<table id="etn_div" style="width:150px; display:auto; text-align:center; margin:10px 0;   background:'.$background.'; border: 1px solid '.$border.'; '.$aligncss.'"><tr>';
									
						 $borderstring = "";
						 if($image == "show")
						 {
							//$html.= '<td style="padding:5px; width:35px;"><img src="https://timg.electroneum.com/Pixel_Tracker?platform=etn" style="width:35px !important; height:29px !important; padding-right:5px; border-right: 1px solid '.$border.'; padding-bottom:0px !important;" /></td>';
							 $html.= '<td style="text-align:center;"><img src="https://timg.electroneum.com/Pixel_Tracker?platform=etn" style="width:auto !important; height:auto !important;border-bottom: 1px solid '.$border.'; padding-bottom:5px !important;" /></td>'; 
							 $html.= '</tr><tr>';
			
						 }
						
						 $etnvalue = $jsonsarray['price_'.strtolower($currency)];
						 $convertedamount = number_format(floatval($amountval) / $etnvalue, 2, '.', ''); 
						 $html.= '<td style="padding:5px 5px 5px 0; text-align:center; vertical-align:middle;"><strong style="  color:'.$color.'; ">'.$convertedamount.' ETN</strong></td>';
						
						 $html.= '</tr></table><div style="clear:both;"></div>';  
						
						/*
						
						$html.= '<span id="etn_div" style="width:200px; height:30px; text-align:left;  padding:5px; display:inline-block; background:'.$background.'; border: 1px solid '.$border.'">';
						
						$borderstring = "";
						if($image == "show")
						{
							$html.= '<img src="'.JURI::Base().'plugins/content/virtuemart_electroneum_prices/images/etn.svg" style="width:35px !important; height:29px !important; padding-right:5px; border-right: 1px solid '.$border.';" />';
';" />';

						}
						
						$etnvalue = $jsonsarray['price_'.strtolower($currency)];
						$convertedamount = number_format(floatval($amountval) / $etnvalue, 2, '.', ''); 
						
						
						$html.= '<strong style="margin-left:10px !important; height:40px !important; display:inline-block !important; color:'.$color.'; vertical-align:middle;">'.$convertedamount.' ETN</strong>';

						
						$html.= '</span>';   */
						


						$article->text = str_replace($fullMatch, $html, $article->text);
				
		
					
					}
		
		
					
							 
							 
					 
				}
			}
			

	}
	
	function onContentAfterDisplay($context, &$article, &$params, $limitstart = 0)
	{
	   
	   
//add your plugin codes here
		return '';
		//return a string value. Returned value from this event will be displayed in a placeholder. 
                // Most templates display this placeholder after the article separator.
	}
	/**
	 * Loads and renders the module
	 *
	 * @param   string  $position  The position assigned to the module
	 * @param   string  $style     The style assigned to the module
	 *
	 * @return  mixed
	 *

	 * @since   1.6
	 */
	protected function _load($position, $style = 'none')
	{
		self::$modules[$position] = '';
		$document = JFactory::getDocument();
		$renderer = $document->loadRenderer('module');
		$modules  = JModuleHelper::getModules($position);
		$params   = array('style' => $style);
		ob_start();

		foreach ($modules as $module)
		{
			echo $renderer->render($module, $params);
		}

		self::$modules[$position] = ob_get_clean();

		return self::$modules[$position];
	}

	/**
	 * This is always going to get the first instance of the module type unless
	 * there is a title.
	 *
	 * @param   string  $module  The module title
	 * @param   string  $title   The title of the module
	 * @param   string  $style   The style of the module
	 *
	 * @return  mixed
	 *
	 * @since   1.6
	 */
	protected function _loadmod($module, $title, $style = 'none')
	{
		self::$mods[$module] = '';
		$document = JFactory::getDocument();
		$renderer = $document->loadRenderer('module');
		$mod      = JModuleHelper::getModule($module, $title);

		// If the module without the mod_ isn't found, try it with mod_.
		// This allows people to enter it either way in the content
		if (!isset($mod))
		{
			$name = 'mod_' . $module;
			$mod  = JModuleHelper::getModule($name, $title);
		}

		$params = array('style' => $style);
		ob_start();

		if ($mod->id)
		{
			echo $renderer->render($mod, $params);
		}

		self::$mods[$module] = ob_get_clean();

		return self::$mods[$module];
	}

}
